# Copyright (c) 2018-2019 VMware, Inc.  All Rights Reserved.
# SPDX-License-Identifier: MIT

# DO NOT MODIFY. THIS CODE IS GENERATED. CHANGES WILL BE OVERWRITTEN.

# appliance - The vCenter Server Appliance is a preconfigured Linux-based virtual machine optimized for running vCenter Server and associated services.


# Common files
require 'vsphere-automation-runtime/api_client'
require 'vsphere-automation-runtime/api_error'
require 'vsphere-automation-runtime/configuration'
require 'vsphere-automation-appliance/version'

# Models
require 'vsphere-automation-appliance/models/appliance_access_consolecli_result'
require 'vsphere-automation-appliance/models/appliance_access_consolecli_set'
require 'vsphere-automation-appliance/models/appliance_access_dcui_result'
require 'vsphere-automation-appliance/models/appliance_access_dcui_set'
require 'vsphere-automation-appliance/models/appliance_access_shell_result'
require 'vsphere-automation-appliance/models/appliance_access_shell_set'
require 'vsphere-automation-appliance/models/appliance_access_shell_shell_config'
require 'vsphere-automation-appliance/models/appliance_access_ssh_result'
require 'vsphere-automation-appliance/models/appliance_access_ssh_set'
require 'vsphere-automation-appliance/models/appliance_health_applmgmt_result'
require 'vsphere-automation-appliance/models/appliance_health_databasestorage_health_level'
require 'vsphere-automation-appliance/models/appliance_health_databasestorage_result'
require 'vsphere-automation-appliance/models/appliance_health_load_health_level'
require 'vsphere-automation-appliance/models/appliance_health_load_result'
require 'vsphere-automation-appliance/models/appliance_health_mem_health_level'
require 'vsphere-automation-appliance/models/appliance_health_mem_result'
require 'vsphere-automation-appliance/models/appliance_health_messages_result'
require 'vsphere-automation-appliance/models/appliance_health_softwarepackages_health_level'
require 'vsphere-automation-appliance/models/appliance_health_softwarepackages_result'
require 'vsphere-automation-appliance/models/appliance_health_storage_health_level'
require 'vsphere-automation-appliance/models/appliance_health_storage_result'
require 'vsphere-automation-appliance/models/appliance_health_swap_health_level'
require 'vsphere-automation-appliance/models/appliance_health_swap_result'
require 'vsphere-automation-appliance/models/appliance_health_system_health_level'
require 'vsphere-automation-appliance/models/appliance_health_system_lastcheck_result'
require 'vsphere-automation-appliance/models/appliance_health_system_result'
require 'vsphere-automation-appliance/models/appliance_local_accounts_config'
require 'vsphere-automation-appliance/models/appliance_local_accounts_create'
require 'vsphere-automation-appliance/models/appliance_local_accounts_info'
require 'vsphere-automation-appliance/models/appliance_local_accounts_list_result'
require 'vsphere-automation-appliance/models/appliance_local_accounts_policy_info'
require 'vsphere-automation-appliance/models/appliance_local_accounts_policy_result'
require 'vsphere-automation-appliance/models/appliance_local_accounts_policy_set'
require 'vsphere-automation-appliance/models/appliance_local_accounts_result'
require 'vsphere-automation-appliance/models/appliance_local_accounts_set'
require 'vsphere-automation-appliance/models/appliance_local_accounts_update'
require 'vsphere-automation-appliance/models/appliance_local_accounts_update_config'
require 'vsphere-automation-appliance/models/appliance_logging_forwarding_config'
require 'vsphere-automation-appliance/models/appliance_logging_forwarding_connection_status'
require 'vsphere-automation-appliance/models/appliance_logging_forwarding_connection_status_state'
require 'vsphere-automation-appliance/models/appliance_logging_forwarding_protocol'
require 'vsphere-automation-appliance/models/appliance_logging_forwarding_result'
require 'vsphere-automation-appliance/models/appliance_logging_forwarding_set'
require 'vsphere-automation-appliance/models/appliance_logging_forwarding_test'
require 'vsphere-automation-appliance/models/appliance_logging_forwarding_test_result'
require 'vsphere-automation-appliance/models/appliance_monitoring_function_type'
require 'vsphere-automation-appliance/models/appliance_monitoring_interval_type'
require 'vsphere-automation-appliance/models/appliance_monitoring_list_result'
require 'vsphere-automation-appliance/models/appliance_monitoring_monitored_item'
require 'vsphere-automation-appliance/models/appliance_monitoring_monitored_item_data'
require 'vsphere-automation-appliance/models/appliance_monitoring_monitored_item_data_request'
require 'vsphere-automation-appliance/models/appliance_monitoring_query_result'
require 'vsphere-automation-appliance/models/appliance_monitoring_result'
require 'vsphere-automation-appliance/models/appliance_networking_dns_info'
require 'vsphere-automation-appliance/models/appliance_networking_dns_info_dns_mode'
require 'vsphere-automation-appliance/models/appliance_networking_dns_domains_add'
require 'vsphere-automation-appliance/models/appliance_networking_dns_domains_list_result'
require 'vsphere-automation-appliance/models/appliance_networking_dns_domains_set'
require 'vsphere-automation-appliance/models/appliance_networking_dns_hostname_message'
require 'vsphere-automation-appliance/models/appliance_networking_dns_hostname_message_status'
require 'vsphere-automation-appliance/models/appliance_networking_dns_hostname_result'
require 'vsphere-automation-appliance/models/appliance_networking_dns_hostname_set'
require 'vsphere-automation-appliance/models/appliance_networking_dns_hostname_test'
require 'vsphere-automation-appliance/models/appliance_networking_dns_hostname_test_result'
require 'vsphere-automation-appliance/models/appliance_networking_dns_hostname_test_status'
require 'vsphere-automation-appliance/models/appliance_networking_dns_hostname_test_status_info'
require 'vsphere-automation-appliance/models/appliance_networking_dns_servers_add'
require 'vsphere-automation-appliance/models/appliance_networking_dns_servers_dns_server_config'
require 'vsphere-automation-appliance/models/appliance_networking_dns_servers_dns_server_mode'
require 'vsphere-automation-appliance/models/appliance_networking_dns_servers_message'
require 'vsphere-automation-appliance/models/appliance_networking_dns_servers_message_status'
require 'vsphere-automation-appliance/models/appliance_networking_dns_servers_result'
require 'vsphere-automation-appliance/models/appliance_networking_dns_servers_set'
require 'vsphere-automation-appliance/models/appliance_networking_dns_servers_test'
require 'vsphere-automation-appliance/models/appliance_networking_dns_servers_test_result'
require 'vsphere-automation-appliance/models/appliance_networking_dns_servers_test_status'
require 'vsphere-automation-appliance/models/appliance_networking_dns_servers_test_status_info'
require 'vsphere-automation-appliance/models/appliance_networking_firewall_inbound_policy'
require 'vsphere-automation-appliance/models/appliance_networking_firewall_inbound_result'
require 'vsphere-automation-appliance/models/appliance_networking_firewall_inbound_rule'
require 'vsphere-automation-appliance/models/appliance_networking_firewall_inbound_set'
require 'vsphere-automation-appliance/models/appliance_networking_info'
require 'vsphere-automation-appliance/models/appliance_networking_info_interfaces'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_interface_info'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_interface_status'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_ipv4_config'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_ipv4_info'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_ipv4_mode'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_ipv4_result'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_ipv4_set'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_ipv6_address'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_ipv6_address_info'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_ipv6_config'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_ipv6_info'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_ipv6_origin'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_ipv6_result'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_ipv6_set'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_ipv6_status'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_list_result'
require 'vsphere-automation-appliance/models/appliance_networking_interfaces_result'
require 'vsphere-automation-appliance/models/appliance_networking_no_proxy_result'
require 'vsphere-automation-appliance/models/appliance_networking_no_proxy_set'
require 'vsphere-automation-appliance/models/appliance_networking_proxy_config'
require 'vsphere-automation-appliance/models/appliance_networking_proxy_list_result'
require 'vsphere-automation-appliance/models/appliance_networking_proxy_list_result_value'
require 'vsphere-automation-appliance/models/appliance_networking_proxy_protocol'
require 'vsphere-automation-appliance/models/appliance_networking_proxy_result'
require 'vsphere-automation-appliance/models/appliance_networking_proxy_server_status'
require 'vsphere-automation-appliance/models/appliance_networking_proxy_set'
require 'vsphere-automation-appliance/models/appliance_networking_proxy_test'
require 'vsphere-automation-appliance/models/appliance_networking_proxy_test_result'
require 'vsphere-automation-appliance/models/appliance_networking_result'
require 'vsphere-automation-appliance/models/appliance_networking_update'
require 'vsphere-automation-appliance/models/appliance_networking_update_spec'
require 'vsphere-automation-appliance/models/appliance_notification'
require 'vsphere-automation-appliance/models/appliance_notifications'
require 'vsphere-automation-appliance/models/appliance_ntp_localizable_message'
require 'vsphere-automation-appliance/models/appliance_ntp_result'
require 'vsphere-automation-appliance/models/appliance_ntp_server_status'
require 'vsphere-automation-appliance/models/appliance_ntp_set'
require 'vsphere-automation-appliance/models/appliance_ntp_test'
require 'vsphere-automation-appliance/models/appliance_ntp_test_result'
require 'vsphere-automation-appliance/models/appliance_ntp_test_run_status'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_backup_request'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_backup_job_status'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_backup_request'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_backup_restore_process_state'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_cancel_result'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_create'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_create_result'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_details_build_info'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_details_filter_spec'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_details_info'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_details_list_result'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_details_list_result_value'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_details_type'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_list_result'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_localizable_message'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_location_type'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_result'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_return_result'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_job_return_status'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_localizable_message'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_location_spec'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_location_type'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_parts_list_result'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_parts_localizable_message'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_parts_part'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_parts_result'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_return_result'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_return_status'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_schedules_create'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_schedules_create_spec'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_schedules_day_of_week'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_schedules_info'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_schedules_list_result'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_schedules_list_result_value'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_schedules_recurrence_info'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_schedules_result'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_schedules_retention_info'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_schedules_run'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_schedules_run_result'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_schedules_update'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_schedules_update_spec'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_system_name_archive_filter_spec'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_system_name_archive_info'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_system_name_archive_list_result'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_system_name_archive_result'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_system_name_archive_summary'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_system_name_list_result'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_validate'
require 'vsphere-automation-appliance/models/appliance_recovery_backup_validate_result'
require 'vsphere-automation-appliance/models/appliance_recovery_info'
require 'vsphere-automation-appliance/models/appliance_recovery_reconciliation_job_create'
require 'vsphere-automation-appliance/models/appliance_recovery_reconciliation_job_create_result'
require 'vsphere-automation-appliance/models/appliance_recovery_reconciliation_job_create_spec'
require 'vsphere-automation-appliance/models/appliance_recovery_reconciliation_job_info'
require 'vsphere-automation-appliance/models/appliance_recovery_reconciliation_job_result'
require 'vsphere-automation-appliance/models/appliance_recovery_reconciliation_job_status'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_job_backup_restore_process_state'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_job_cancel_result'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_job_create'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_job_create_result'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_job_localizable_message'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_job_location_type'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_job_restore_job_status'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_job_restore_request'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_job_result'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_job_return_result'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_job_return_status'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_localizable_message'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_location_type'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_metadata'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_restore_request'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_validate'
require 'vsphere-automation-appliance/models/appliance_recovery_restore_validate_result'
require 'vsphere-automation-appliance/models/appliance_recovery_result'
require 'vsphere-automation-appliance/models/appliance_services_info'
require 'vsphere-automation-appliance/models/appliance_services_list_result'
require 'vsphere-automation-appliance/models/appliance_services_list_result_value'
require 'vsphere-automation-appliance/models/appliance_services_result'
require 'vsphere-automation-appliance/models/appliance_services_state'
require 'vsphere-automation-appliance/models/appliance_shutdown_poweroff'
require 'vsphere-automation-appliance/models/appliance_shutdown_reboot'
require 'vsphere-automation-appliance/models/appliance_shutdown_result'
require 'vsphere-automation-appliance/models/appliance_shutdown_shutdown_config'
require 'vsphere-automation-appliance/models/appliance_subtask_info'
require 'vsphere-automation-appliance/models/appliance_system_storage_list_result'
require 'vsphere-automation-appliance/models/appliance_system_storage_resize_ex_result'
require 'vsphere-automation-appliance/models/appliance_system_storage_resize_ex_result_value'
require 'vsphere-automation-appliance/models/appliance_system_storage_storage_change'
require 'vsphere-automation-appliance/models/appliance_system_storage_storage_mapping'
require 'vsphere-automation-appliance/models/appliance_system_time_result'
require 'vsphere-automation-appliance/models/appliance_system_time_system_time_struct'
require 'vsphere-automation-appliance/models/appliance_system_time_timezone_result'
require 'vsphere-automation-appliance/models/appliance_system_time_timezone_set'
require 'vsphere-automation-appliance/models/appliance_system_uptime_result'
require 'vsphere-automation-appliance/models/appliance_system_version_result'
require 'vsphere-automation-appliance/models/appliance_system_version_version_struct'
require 'vsphere-automation-appliance/models/appliance_task_info'
require 'vsphere-automation-appliance/models/appliance_task_info_subtasks'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_hash'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_hash_result'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_limits_result'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_result'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_snmp_auth_proto'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_snmp_config'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_snmp_config_read_only'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_snmp_hash_config'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_snmp_hash_results'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_snmp_limits'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_snmp_priv_proto'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_snmp_remote_user'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_snmp_sec_level'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_snmp_stats'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_snmp_test_results'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_snmp_user'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_snm_pv1_trap_target'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_snm_pv3_notfication'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_snm_pv3_target'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_set'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_stats_result'
require 'vsphere-automation-appliance/models/appliance_techpreview_monitoring_snmp_test_result'
require 'vsphere-automation-appliance/models/appliance_techpreview_services_status_get'
require 'vsphere-automation-appliance/models/appliance_techpreview_services_status_result'
require 'vsphere-automation-appliance/models/appliance_techpreview_services_status_service_status'
require 'vsphere-automation-appliance/models/appliance_timesync_result'
require 'vsphere-automation-appliance/models/appliance_timesync_set'
require 'vsphere-automation-appliance/models/appliance_timesync_time_sync_mode'
require 'vsphere-automation-appliance/models/appliance_update_common_info_category'
require 'vsphere-automation-appliance/models/appliance_update_common_info_priority'
require 'vsphere-automation-appliance/models/appliance_update_common_info_severity'
require 'vsphere-automation-appliance/models/appliance_update_info'
require 'vsphere-automation-appliance/models/appliance_update_pending_info'
require 'vsphere-automation-appliance/models/appliance_update_pending_install'
require 'vsphere-automation-appliance/models/appliance_update_pending_install_user_data'
require 'vsphere-automation-appliance/models/appliance_update_pending_list_result'
require 'vsphere-automation-appliance/models/appliance_update_pending_precheck_result'
require 'vsphere-automation-appliance/models/appliance_update_pending_question'
require 'vsphere-automation-appliance/models/appliance_update_pending_question_input_type'
require 'vsphere-automation-appliance/models/appliance_update_pending_result'
require 'vsphere-automation-appliance/models/appliance_update_pending_source_type'
require 'vsphere-automation-appliance/models/appliance_update_pending_stage_and_install'
require 'vsphere-automation-appliance/models/appliance_update_pending_validate'
require 'vsphere-automation-appliance/models/appliance_update_pending_validate_result'
require 'vsphere-automation-appliance/models/appliance_update_policy_config'
require 'vsphere-automation-appliance/models/appliance_update_policy_day_of_week'
require 'vsphere-automation-appliance/models/appliance_update_policy_info'
require 'vsphere-automation-appliance/models/appliance_update_policy_result'
require 'vsphere-automation-appliance/models/appliance_update_policy_set'
require 'vsphere-automation-appliance/models/appliance_update_policy_time'
require 'vsphere-automation-appliance/models/appliance_update_result'
require 'vsphere-automation-appliance/models/appliance_update_service_info'
require 'vsphere-automation-appliance/models/appliance_update_staged_info'
require 'vsphere-automation-appliance/models/appliance_update_staged_result'
require 'vsphere-automation-appliance/models/appliance_update_state'
require 'vsphere-automation-appliance/models/appliance_update_summary'
require 'vsphere-automation-appliance/models/appliance_vmon_service_health'
require 'vsphere-automation-appliance/models/appliance_vmon_service_info'
require 'vsphere-automation-appliance/models/appliance_vmon_service_list_details_result'
require 'vsphere-automation-appliance/models/appliance_vmon_service_list_details_result_value'
require 'vsphere-automation-appliance/models/appliance_vmon_service_result'
require 'vsphere-automation-appliance/models/appliance_vmon_service_startup_type'
require 'vsphere-automation-appliance/models/appliance_vmon_service_state'
require 'vsphere-automation-appliance/models/appliance_vmon_service_update'
require 'vsphere-automation-appliance/models/appliance_vmon_service_update_spec'
require 'vsphere-automation-appliance/models/cis_task_progress'
require 'vsphere-automation-appliance/models/cis_task_status'
require 'vsphere-automation-appliance/models/vapi_std_dynamic_id'
require 'vsphere-automation-appliance/models/vapi_std_errors_already_exists'
require 'vsphere-automation-appliance/models/vapi_std_errors_already_exists_error'
require 'vsphere-automation-appliance/models/vapi_std_errors_already_in_desired_state'
require 'vsphere-automation-appliance/models/vapi_std_errors_already_in_desired_state_error'
require 'vsphere-automation-appliance/models/vapi_std_errors_error'
require 'vsphere-automation-appliance/models/vapi_std_errors_error_error'
require 'vsphere-automation-appliance/models/vapi_std_errors_feature_in_use'
require 'vsphere-automation-appliance/models/vapi_std_errors_feature_in_use_error'
require 'vsphere-automation-appliance/models/vapi_std_errors_invalid_argument'
require 'vsphere-automation-appliance/models/vapi_std_errors_invalid_argument_error'
require 'vsphere-automation-appliance/models/vapi_std_errors_not_allowed_in_current_state'
require 'vsphere-automation-appliance/models/vapi_std_errors_not_allowed_in_current_state_error'
require 'vsphere-automation-appliance/models/vapi_std_errors_not_found'
require 'vsphere-automation-appliance/models/vapi_std_errors_not_found_error'
require 'vsphere-automation-appliance/models/vapi_std_errors_resource_busy'
require 'vsphere-automation-appliance/models/vapi_std_errors_resource_busy_error'
require 'vsphere-automation-appliance/models/vapi_std_errors_timed_out'
require 'vsphere-automation-appliance/models/vapi_std_errors_timed_out_error'
require 'vsphere-automation-appliance/models/vapi_std_errors_unable_to_allocate_resource'
require 'vsphere-automation-appliance/models/vapi_std_errors_unable_to_allocate_resource_error'
require 'vsphere-automation-appliance/models/vapi_std_errors_unauthenticated'
require 'vsphere-automation-appliance/models/vapi_std_errors_unauthenticated_error'
require 'vsphere-automation-appliance/models/vapi_std_errors_unauthorized'
require 'vsphere-automation-appliance/models/vapi_std_errors_unauthorized_error'
require 'vsphere-automation-appliance/models/vapi_std_localizable_message'

# APIs
require 'vsphere-automation-appliance/api/access_consolecli_api'
require 'vsphere-automation-appliance/api/access_dcui_api'
require 'vsphere-automation-appliance/api/access_shell_api'
require 'vsphere-automation-appliance/api/access_ssh_api'
require 'vsphere-automation-appliance/api/health_api'
require 'vsphere-automation-appliance/api/health_applmgmt_api'
require 'vsphere-automation-appliance/api/health_databasestorage_api'
require 'vsphere-automation-appliance/api/health_load_api'
require 'vsphere-automation-appliance/api/health_mem_api'
require 'vsphere-automation-appliance/api/health_softwarepackages_api'
require 'vsphere-automation-appliance/api/health_storage_api'
require 'vsphere-automation-appliance/api/health_swap_api'
require 'vsphere-automation-appliance/api/health_system_api'
require 'vsphere-automation-appliance/api/local_accounts_api'
require 'vsphere-automation-appliance/api/local_accounts_policy_api'
require 'vsphere-automation-appliance/api/logging_forwarding_api'
require 'vsphere-automation-appliance/api/monitoring_api'
require 'vsphere-automation-appliance/api/networking_api'
require 'vsphere-automation-appliance/api/networking_dns_domains_api'
require 'vsphere-automation-appliance/api/networking_dns_hostname_api'
require 'vsphere-automation-appliance/api/networking_dns_servers_api'
require 'vsphere-automation-appliance/api/networking_firewall_inbound_api'
require 'vsphere-automation-appliance/api/networking_interfaces_api'
require 'vsphere-automation-appliance/api/networking_interfaces_ipv4_api'
require 'vsphere-automation-appliance/api/networking_interfaces_ipv6_api'
require 'vsphere-automation-appliance/api/networking_no_proxy_api'
require 'vsphere-automation-appliance/api/networking_proxy_api'
require 'vsphere-automation-appliance/api/ntp_api'
require 'vsphere-automation-appliance/api/recovery_api'
require 'vsphere-automation-appliance/api/recovery_backup_api'
require 'vsphere-automation-appliance/api/recovery_backup_job_api'
require 'vsphere-automation-appliance/api/recovery_backup_job_details_api'
require 'vsphere-automation-appliance/api/recovery_backup_parts_api'
require 'vsphere-automation-appliance/api/recovery_backup_schedules_api'
require 'vsphere-automation-appliance/api/recovery_backup_system_name_api'
require 'vsphere-automation-appliance/api/recovery_backup_system_name_archive_api'
require 'vsphere-automation-appliance/api/recovery_reconciliation_job_api'
require 'vsphere-automation-appliance/api/recovery_restore_api'
require 'vsphere-automation-appliance/api/recovery_restore_job_api'
require 'vsphere-automation-appliance/api/services_api'
require 'vsphere-automation-appliance/api/shutdown_api'
require 'vsphere-automation-appliance/api/system_storage_api'
require 'vsphere-automation-appliance/api/system_time_api'
require 'vsphere-automation-appliance/api/system_time_timezone_api'
require 'vsphere-automation-appliance/api/system_uptime_api'
require 'vsphere-automation-appliance/api/system_version_api'
require 'vsphere-automation-appliance/api/techpreview_monitoring_snmp_api'
require 'vsphere-automation-appliance/api/techpreview_services_status_api'
require 'vsphere-automation-appliance/api/timesync_api'
require 'vsphere-automation-appliance/api/update_api'
require 'vsphere-automation-appliance/api/update_pending_api'
require 'vsphere-automation-appliance/api/update_policy_api'
require 'vsphere-automation-appliance/api/update_staged_api'
require 'vsphere-automation-appliance/api/vmon_service_api'

module VSphereAutomation
  class << self
    # Customize default settings for the SDK using block.
    #   VSphereAutomation.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end
